import { Ref } from 'vue-demi';
import { Plot as BasePlot } from '@antv/g2plot';
import { HTMLAttributes } from '@vue/runtime-dom';
interface Options {
    [x: string]: any;
}
export interface Plot<C extends Options> extends BasePlot<C> {
    new (container: HTMLElement, config: C): BasePlot<C>;
}
declare type PickedAttrs = 'class' | 'style';
export interface BaseChartProps<C extends Options> extends Pick<HTMLAttributes, PickedAttrs> {
    chart: any;
    data: any[];
    chartRef?: Ref<BasePlot<C> | null>;
}
export interface BaseChartRawBindings<C extends Options> {
    plot: BasePlot<C>;
}
declare const BaseChart: any;
export default BaseChart;
