"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/objectSpread2"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/objectWithoutProperties"));

var _vueDemi = require("vue-demi");

var _isEqual = _interopRequireDefault(require("lodash/isEqual"));

var _excluded = ["chart", "chartRef", "data", "class", "style"];
var BaseChart = (0, _vueDemi.defineComponent)({
  inheritAttrs: false,
  name: 'BaseChart',
  computed: {
    attrConfig: function attrConfig() {
      return this.$attrs;
    },
    chartData: function chartData() {
      var data = this.attrConfig.data;
      return data || [];
    },
    chartConfig: function chartConfig() {
      var _this$attrConfig = this.attrConfig,
          chart = _this$attrConfig.chart,
          chartRef = _this$attrConfig.chartRef,
          data = _this$attrConfig.data,
          className = _this$attrConfig.class,
          style = _this$attrConfig.style,
          config = (0, _objectWithoutProperties2.default)(_this$attrConfig, _excluded);
      return config;
    }
  },
  mounted: function mounted() {
    var chartRef = this.$attrs.chartRef;
    var Chart = this.attrConfig.chart;
    var plot = new Chart(this.$el, (0, _objectSpread2.default)({
      data: this.chartData
    }, this.chartConfig));
    plot.render();

    if (chartRef) {
      chartRef.value = plot;
    }

    this.plot = plot;
  },
  beforeUnmount: function beforeUnmount() {
    /* istanbul ignore else */
    if (this.plot) {
      this.plot.destroy();
    }
  },
  watch: {
    chartData: function chartData(data, oldData) {
      /* istanbul ignore else */
      if (this.plot) {
        if (!oldData.length) {
          this.plot.update((0, _objectSpread2.default)({
            data: data
          }, this.chartConfig));
          this.plot.render();
        } else {
          this.plot.changeData(data);
        }
      }
    },
    chartConfig: function chartConfig(config, oldConfig) {
      /* istanbul ignore else */
      if (this.plot) {
        if (!(0, _isEqual.default)(config, oldConfig)) {
          this.plot.update((0, _objectSpread2.default)({
            data: this.chartData
          }, config));
        }
      }
    }
  },
  render: function render() {
    var h = arguments[0];
    return h("div", {
      "class": this.attrConfig.class,
      "style": this.attrConfig.style
    });
  }
});
var _default = BaseChart;
exports.default = _default;